/*
	A basic extension of the java.awt.Dialog class
 */

import java.awt.*;
import java.io.*;
import javax.swing.*;

public class HypDialog extends Dialog
{
    String[] filenamelist = new String[20];
    boolean Text_Typed = false;
    String cadvalue="";  // current typed text
    boolean NOTFILE = false;
    String DIR_TOP=""; // directory where station*.hyp are located
    String FILENAME = ""; // absolute path of station*.hyp
    String IFaceSet="N,B"; // set of values allowed for interface 
    String VelRange="0,10"; // range of values allowed for velocity
    String DepRange="-999,9999"; // range of depth allowed
    String LatRange="-90,90"; // range of Lat
    String LonRange="-180,180"; // range of Lon
    String AltRange="-999,9999"; // range of elevation
    String CorrRange="-999,999"; // range of P-delay
    String[] RTEST = new String[100];
    String[] TESTHELP = new String[100];
    int PREVINDEX=-1; // current selected index on ResetList
    boolean VALID=true; // keep trace when the value is valid
    int STAINDEX=-1; // current selected index on StaList
    int MODELINDEX=-1; // current selected index on StaList
    String INPUTDEF_DIR = "";
    List StaTransp = new List();
    List ModelTransp = new List();
    StringFormat Format = new StringFormat();
	public HypDialog(Frame parent)
	{
		super(parent);

		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setSize(643,516);
		setVisible(false);
		CancelButt.setLabel("CANCEL");
		add(CancelButt);
		CancelButt.setBounds(468,336,156,36);
		OKButt.setLabel("SAVE & EXIT");
		add(OKButt);
		OKButt.setBounds(468,288,156,36);
		ResetList.add(" (02)Step length damping control=500.0");
		ResetList.add(" (07)Coda magnitude coefficient=0.087");
		ResetList.add(" (08)Coda magnitude coefficient=2.0");
		ResetList.add(" (09)Coda magnitude coefficient=0.0035");
		ResetList.add(" (11)Max iterat in RMS minimiza=99.0");
		ResetList.add(" (13)Increment(km) for aux RMS=20.0");
		ResetList.add(" (30)Initial damping factor=0.005");
		ResetList.add(" (31)Max degs of freedom=3.0");
		ResetList.add(" (32)Magnit change for converg=0.05");
		ResetList.add(" (34)Min spread to normalize resid=0.1");
		ResetList.add(" (35)Bisquare weighting width=4.685");
		ResetList.add(" (36)Low RMS limit for bisquare=0.0");
		ResetList.add(" (37)Max increase in damping=10.0");
		ResetList.add(" (38)Using least squares errors=0.0");
		ResetList.add(" (39)Damping increment factor=4.0");
		ResetList.add(" (40)Depht origin of coordinate=0.0");
		ResetList.add(" (41)Max dist for hyp solution=20000");
		ResetList.add(" (43)Min RMS for residual=1.5");
		ResetList.add(" (44)Rg phase velocity=3.0");
		ResetList.add(" (45)Min RMS difference=50.0");
		ResetList.add(" (46)Min phases for average=3.0");
		ResetList.add(" (47)Prevent depth to go=0.0");
		ResetList.add(" (49)T-phase velocity=1.48");
		ResetList.add(" (50)Using azimuth phases=1.0");
		ResetList.add(" (51)Lg phase velocity=3.5");
		ResetList.add(" (52)Weighting in azimuth inver=5.0");
		ResetList.add(" (53)Critical dist moved to=130.0");
		ResetList.add(" (56)Using STARTLOC algorithm=1.0");
		ResetList.add(" (57)Dist for IASPEI91 tables=1500");
		ResetList.add(" (58)Max Apparent velocity=100.0");
		ResetList.add(" (59)Critical dist for PKP=13000");
		ResetList.add(" (60)Arrival time difference=5.0");
		ResetList.add(" (61)App veloc regression resid=2.0");
		ResetList.add(" (62)Using IASPEI91 phases=1.0");
		ResetList.add(" (63)Types of phases used=0.0");
		ResetList.add(" (64)RMS temporary increase=2.0");
		ResetList.add(" (65)Iterat for RMS increase=3.0");
		ResetList.add(" (66)Print out tt errors=0.0");
		ResetList.add(" (67)Using blank phases as P=0.0");
		ResetList.add(" (68)Apparent P velocity=5.0");
		ResetList.add(" (69)PKP first arrival dist=110.0");
		ResetList.add(" (70)Max depth of hyp solution=700");
		ResetList.add(" (71)Sort output in distance=1.0");
		ResetList.add(" (72)Auto phase identification=0.0");
		ResetList.add(" (73)Iterat with first P's=3.0");
		ResetList.add(" (74)Print input phase data=0.0");
		ResetList.add(" (75)Local magnitude coeff=1.0");
		ResetList.add(" (76)Local magnitude coeff=1.11");
		ResetList.add(" (77)Local magnitude coeff=0.00189");
		ResetList.add(" (78)Local magnitude coeff=-2.09");
		ResetList.add(" (79)Min no of stations=1.0");
		ResetList.add(" (80)Min no of phases=3.0");
		ResetList.add(" (81)Disable loc of local=1.0");
		ResetList.add(" (82)Disable loc of regional=1.0");
		ResetList.add(" (83)Disable loc of distant=1.0");
		ResetList.add(" (84)Ellipticity correction=1.0");
		ResetList.add(" (85)Prior error of local=0.1");
		ResetList.add(" (86)Degs of freedom test(85)=8.0");
		ResetList.add(" (87)Confidence level=0.1");
		ResetList.add(" (88)RMS for distant events=10000.0");
		ResetList.add(" (89)Using depth phases=1.0");
		ResetList.add(" (90)Using core phases=1.0");
		ResetList.add(" (91)Same as (85) for distant=1.0");
		ResetList.add(" (92)Degs of freedom test(91)=8.0");
		ResetList.add(" (93)Output longitude positive=0.0");
		ResetList.add(" (94)Residual for zero weight=0.0");
		ResetList.add(" (95)Using core phases(135-150)=0.0");
		ResetList.add(" (96)Depth variation for min RMS=0.0");
		ResetList.add(" (97)Minute error correction=0.0");
		ResetList.add(" (98)Spher harmonic sta correct=0.0");
		ResetList.add(" (99)Permanent Lg weight=1.0");
		ResetList.add(" (100)Permanent Rg weight=1.0");
		ResetList.add(" (101)Permanent T weight=0.0");
		ResetList.add(" (103)Min dep phases for start=1.0");
		ResetList.add(" (104)Min dist from array=30.0");
		ResetList.add(" (105)Using gradient model=0.0");
		ResetList.add(" (106)Only calculate mag & spec=0.0");
		ResetList.setBackground(java.awt.Color.white);
		ResetList.setFont(new Font("Courier", Font.PLAIN, 12));
		add(ResetList);
		ResetList.setBounds(24,36,252,132);
		StaList.setBackground(java.awt.Color.white);
		StaList.setFont(new Font("Courier", Font.PLAIN, 12));
		add(StaList);
		StaList.setBounds(312,36,144,132);
		add(StaName);
		StaName.setBounds(552,36,72,28);
		add(LatEdit);
		LatEdit.setBounds(552,72,72,28);
		add(LonEdit);
		LonEdit.setBounds(552,108,72,28);
		add(AltEdit);
		AltEdit.setBounds(552,144,72,28);
		add(CorrectEdit);
		CorrectEdit.setBounds(552,180,72,28);
		ModelList.setBackground(java.awt.Color.white);
		ModelList.setFont(new Font("Courier", Font.PLAIN, 12));
		add(ModelList);
		ModelList.setBounds(24,264,132,84);
		AddSta.setLabel("Add");
		add(AddSta);
		AddSta.setBounds(312,180,60,24);
		RemSta.setLabel("Remove");
		add(RemSta);
		RemSta.setBounds(396,180,60,24);
		add(TestEdit);
		TestEdit.setBounds(72,180,72,28);
		add(IFaceEdit);
		IFaceEdit.setBounds(312,276,36,28);
		add(DepEdit);
		DepEdit.setBounds(240,276,60,28);
		add(VelEdit);
		VelEdit.setBounds(168,276,60,28);
		AddLayer.setLabel("Add");
		add(AddLayer);
		AddLayer.setBounds(168,324,60,24);
		RemLayer.setLabel("Remove");
		add(RemLayer);
		RemLayer.setBounds(240,324,60,24);
		add(StrDepEdit);
		StrDepEdit.setBounds(48,408,60,28);
		add(XnearEdit);
		XnearEdit.setBounds(132,408,60,28);
		add(XfarEdit);
		XfarEdit.setBounds(216,408,60,28);
		add(VpVsEdit);
		VpVsEdit.setBounds(300,408,60,28);
		add(NDepEdit);
		NDepEdit.setBounds(384,408,60,28);
		add(InitDepEdit);
		InitDepEdit.setBounds(468,408,60,28);
		add(IncDepEdit);
		IncDepEdit.setBounds(552,408,60,28);
		label2.setText("GENERAL PARAMETERS");
		label2.setAlignment(java.awt.Label.CENTER);
		add(label2);
		label2.setBackground(new java.awt.Color(228,228,228));
		label2.setBounds(24,12,216,24);
		label4.setText("VALUE:");
		label4.setAlignment(java.awt.Label.CENTER);
		add(label4);
		label4.setBackground(new java.awt.Color(228,228,228));
		label4.setBounds(24,180,48,24);
		label5.setText("STATION  LIST");
		label5.setAlignment(java.awt.Label.CENTER);
		add(label5);
		label5.setBackground(new java.awt.Color(228,228,228));
		label5.setBounds(312,12,144,24);
		label6.setText("Latitude:");
		label6.setAlignment(java.awt.Label.RIGHT);
		add(label6);
		label6.setBackground(new java.awt.Color(228,228,228));
		label6.setBounds(456,72,84,24);
		label7.setText("Longitude:");
		label7.setAlignment(java.awt.Label.RIGHT);
		add(label7);
		label7.setBackground(new java.awt.Color(228,228,228));
		label7.setBounds(456,108,84,24);
		label8.setText("Elevation:");
		label8.setAlignment(java.awt.Label.RIGHT);
		add(label8);
		label8.setBackground(new java.awt.Color(228,228,228));
		label8.setBounds(456,144,84,24);
		label9.setText("Name:");
		label9.setAlignment(java.awt.Label.RIGHT);
		add(label9);
		label9.setBackground(new java.awt.Color(228,228,228));
		label9.setBounds(456,36,84,24);
		label10.setText("P-Delay:");
		label10.setAlignment(java.awt.Label.RIGHT);
		add(label10);
		label10.setBackground(new java.awt.Color(228,228,228));
		label10.setBounds(456,180,84,24);
		label11.setText("P-VELOCITY MODEL");
		label11.setAlignment(java.awt.Label.CENTER);
		add(label11);
		label11.setBackground(new java.awt.Color(228,228,228));
		label11.setBounds(24,240,132,24);
		label12.setText("Veloc.");
		label12.setAlignment(java.awt.Label.CENTER);
		add(label12);
		label12.setBackground(new java.awt.Color(228,228,228));
		label12.setBounds(168,252,60,24);
		label13.setText("Depth");
		label13.setAlignment(java.awt.Label.CENTER);
		add(label13);
		label13.setBackground(new java.awt.Color(228,228,228));
		label13.setBounds(240,252,60,24);
		label14.setText("Interf.");
		add(label14);
		label14.setBackground(new java.awt.Color(228,228,228));
		label14.setBounds(312,252,60,24);
		label15.setText("Start-Dep.");
		label15.setAlignment(java.awt.Label.CENTER);
		add(label15);
		label15.setBounds(36,384,84,24);
		label16.setText("Xnear");
		label16.setAlignment(java.awt.Label.CENTER);
		add(label16);
		label16.setBounds(132,384,60,24);
		label17.setText("Xfar");
		label17.setAlignment(java.awt.Label.CENTER);
		add(label17);
		label17.setBounds(216,384,60,24);
		label18.setText("Vp/Vs");
		label18.setAlignment(java.awt.Label.CENTER);
		add(label18);
		label18.setBounds(300,384,60,24);
		label19.setText("NDep.");
		label19.setAlignment(java.awt.Label.CENTER);
		add(label19);
		label19.setBounds(384,384,60,24);
		label20.setText("Init-Dep.");
		label20.setAlignment(java.awt.Label.CENTER);
		add(label20);
		label20.setBounds(468,384,60,24);
		label21.setText("Inc-Dep.");
		label21.setAlignment(java.awt.Label.CENTER);
		add(label21);
		label21.setBounds(552,384,60,24);
		panel2.setLayout(null);
		add(panel2);
		panel2.setBackground(new java.awt.Color(228,228,228));
		panel2.setBounds(300,12,336,204);
		panel3.setLayout(null);
		add(panel3);
		panel3.setBackground(new java.awt.Color(228,228,228));
		panel3.setBounds(12,240,360,132);
		add(AgencyEdit);
		AgencyEdit.setBounds(552,240,72,28);
		label3.setText("Reporting Agency:");
		label3.setAlignment(java.awt.Label.RIGHT);
		add(label3);
		label3.setBounds(408,240,132,24);
		UsedCheck.setLabel("Used");
		add(UsedCheck);
		UsedCheck.setBackground(new java.awt.Color(228,228,228));
		UsedCheck.setBounds(180,180,72,24);
		panel1.setLayout(null);
		add(panel1);
		panel1.setBackground(new java.awt.Color(228,228,228));
		panel1.setBounds(12,12,276,204);
		add(Modelchoice);
		Modelchoice.setBounds(384,300,48,21);
		label1.setText("Model");
		add(label1);
		label1.setBounds(384,276,48,24);
		add(labelHlp);
		labelHlp.setBounds(12,446,612,60);
		setTitle("CONFIGURATION OF STATION0.HYP");
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		OKButt.addActionListener(lSymAction);
		CancelButt.addActionListener(lSymAction);
		SymItem lSymItem = new SymItem();
		ResetList.addItemListener(lSymItem);
		SymText lSymText = new SymText();
		TestEdit.addTextListener(lSymText);
		SymKey aSymKey = new SymKey();
		TestEdit.addKeyListener(aSymKey);
		StaList.addItemListener(lSymItem);
		StaName.addTextListener(lSymText);
		StaName.addKeyListener(aSymKey);
		LatEdit.addTextListener(lSymText);
		LatEdit.addKeyListener(aSymKey);
		LonEdit.addTextListener(lSymText);
		LonEdit.addKeyListener(aSymKey);
		AltEdit.addTextListener(lSymText);
		AltEdit.addKeyListener(aSymKey);
		CorrectEdit.addTextListener(lSymText);
		CorrectEdit.addKeyListener(aSymKey);
		ModelList.addItemListener(lSymItem);
		VelEdit.addTextListener(lSymText);
		VelEdit.addKeyListener(aSymKey);
		DepEdit.addTextListener(lSymText);
		DepEdit.addKeyListener(aSymKey);
		IFaceEdit.addTextListener(lSymText);
		IFaceEdit.addKeyListener(aSymKey);
		AddSta.addActionListener(lSymAction);
		RemSta.addActionListener(lSymAction);
		AddLayer.addActionListener(lSymAction);
		RemLayer.addActionListener(lSymAction);
		UsedCheck.addItemListener(lSymItem);
		SymFocus aSymFocus = new SymFocus();
		TestEdit.addFocusListener(aSymFocus);
		StaName.addFocusListener(aSymFocus);
		LatEdit.addFocusListener(aSymFocus);
		LonEdit.addFocusListener(aSymFocus);
		AltEdit.addFocusListener(aSymFocus);
		CorrectEdit.addFocusListener(aSymFocus);
		VelEdit.addFocusListener(aSymFocus);
		DepEdit.addFocusListener(aSymFocus);
		IFaceEdit.addFocusListener(aSymFocus);
		StrDepEdit.addFocusListener(aSymFocus);
		XnearEdit.addFocusListener(aSymFocus);
		XfarEdit.addFocusListener(aSymFocus);
		VpVsEdit.addFocusListener(aSymFocus);
		NDepEdit.addFocusListener(aSymFocus);
		InitDepEdit.addFocusListener(aSymFocus);
		IncDepEdit.addFocusListener(aSymFocus);
		Modelchoice.addItemListener(lSymItem);
		StaList.addFocusListener(aSymFocus);
		ModelList.addFocusListener(aSymFocus);
		Modelchoice.addFocusListener(aSymFocus);
		AgencyEdit.addFocusListener(aSymFocus);
		//}}
	}
	
	public HypDialog(Frame parent, boolean modal,String seistop,String inputdefdir)
	{
		this(parent);
        setModal(modal);
        DIR_TOP = seistop;
        INPUTDEF_DIR = inputdefdir;
        getModelFiles(); // get the list of available station?.hyp
        getResetListDef(); // get the stationdef.inp
        ReadFile(FILENAME); // read station?.hyp
	}
	
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;


	public HypDialog(Frame parent, String title, boolean modal)
	{
		this(parent, modal,"","");
		setTitle(title);
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			Rectangle bounds = getParent().getBounds();
			Rectangle abounds = getBounds();
	
			setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);
		}
		super.setVisible(b);
	}

	//{{DECLARE_CONTROLS
	java.awt.Button CancelButt = new java.awt.Button();
	java.awt.Button OKButt = new java.awt.Button();
	java.awt.List ResetList = new java.awt.List(4);
	java.awt.List StaList = new java.awt.List(4);
	java.awt.TextField StaName = new java.awt.TextField();
	java.awt.TextField LatEdit = new java.awt.TextField();
	java.awt.TextField LonEdit = new java.awt.TextField();
	java.awt.TextField AltEdit = new java.awt.TextField();
	java.awt.TextField CorrectEdit = new java.awt.TextField();
	java.awt.List ModelList = new java.awt.List(4);
	java.awt.Button AddSta = new java.awt.Button();
	java.awt.Button RemSta = new java.awt.Button();
	java.awt.TextField TestEdit = new java.awt.TextField();
	java.awt.TextField IFaceEdit = new java.awt.TextField();
	java.awt.TextField DepEdit = new java.awt.TextField();
	java.awt.TextField VelEdit = new java.awt.TextField();
	java.awt.Button AddLayer = new java.awt.Button();
	java.awt.Button RemLayer = new java.awt.Button();
	java.awt.TextField StrDepEdit = new java.awt.TextField();
	java.awt.TextField XnearEdit = new java.awt.TextField();
	java.awt.TextField XfarEdit = new java.awt.TextField();
	java.awt.TextField VpVsEdit = new java.awt.TextField();
	java.awt.TextField NDepEdit = new java.awt.TextField();
	java.awt.TextField InitDepEdit = new java.awt.TextField();
	java.awt.TextField IncDepEdit = new java.awt.TextField();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.Label label7 = new java.awt.Label();
	java.awt.Label label8 = new java.awt.Label();
	java.awt.Label label9 = new java.awt.Label();
	java.awt.Label label10 = new java.awt.Label();
	java.awt.Label label11 = new java.awt.Label();
	java.awt.Label label12 = new java.awt.Label();
	java.awt.Label label13 = new java.awt.Label();
	java.awt.Label label14 = new java.awt.Label();
	java.awt.Label label15 = new java.awt.Label();
	java.awt.Label label16 = new java.awt.Label();
	java.awt.Label label17 = new java.awt.Label();
	java.awt.Label label18 = new java.awt.Label();
	java.awt.Label label19 = new java.awt.Label();
	java.awt.Label label20 = new java.awt.Label();
	java.awt.Label label21 = new java.awt.Label();
	java.awt.Panel panel2 = new java.awt.Panel();
	java.awt.Panel panel3 = new java.awt.Panel();
	java.awt.TextField AgencyEdit = new java.awt.TextField();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Checkbox UsedCheck = new java.awt.Checkbox();
	java.awt.Panel panel1 = new java.awt.Panel();
	java.awt.Choice Modelchoice = new java.awt.Choice();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.TextArea labelHlp = new java.awt.TextArea();
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowOpened(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == HypDialog.this)
				HypDialog_WindowOpened(event);
		}

		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == HypDialog.this)
				HypDialog_WindowClosing(event);
		}
	}
	
	void HypDialog_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == OKButt)
				OKButt_ActionPerformed(event);
			else if (object == CancelButt)
				CancelButt_ActionPerformed(event);
			else if (object == AddSta)
				AddSta_ActionPerformed(event);
			else if (object == RemSta)
				RemSta_ActionPerformed(event);
			else if (object == AddLayer)
				AddLayer_ActionPerformed(event);
			else if (object == RemLayer)
				RemLayer_ActionPerformed(event);
		}
	}

	void OKButt_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// Close the window and Save
		 WriteFile(FILENAME);
		 setVisible(false);	 
	}

	void CancelButt_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// Close the window and Cancel
		setVisible(false);	 	 
	}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == ResetList)
				ResetList_ItemStateChanged(event);
			else if (object == StaList)
				StaList_ItemStateChanged(event);
			else if (object == ModelList)
				ModelList_ItemStateChanged(event);
			else if (object == UsedCheck)
				UsedCheck_ItemStateChanged(event);
			else if (object == Modelchoice)
				Modelchoice_ItemStateChanged(event);
		}
	}

	void ResetList_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		// Put the value in the edit box
	  //if ( VALID ) {
		String cad = ResetList.getSelectedItem();
		int j = cad.indexOf("=");
		TestEdit.setText(cad.substring(j+1));	 
		if( cad.charAt(0)=='*') UsedCheck.setState(true);
		else UsedCheck.setState(false);
		if( !Text_Typed )
		 PREVINDEX = ResetList.getSelectedIndex();
		labelHlp.setText(TESTHELP[ResetList.getSelectedIndex()]); 
	 /* }	 
		else if ( PREVINDEX!=-1 )
		 ResetList.select(PREVINDEX);
		 else ResetList.deselect(ResetList.getSelectedIndex()); */
	}

	class SymText implements java.awt.event.TextListener
	{
		public void textValueChanged(java.awt.event.TextEvent event)
		{
			Object object = event.getSource();
			if (object == TestEdit)
				TestEdit_TextValueChanged(event);
			else if (object == StaName)
				StaName_TextValueChanged(event);
			else if (object == LatEdit)
				LatEdit_TextValueChanged(event);
			else if (object == LonEdit)
				LonEdit_TextValueChanged(event);
			else if (object == AltEdit)
				AltEdit_TextValueChanged(event);
			else if (object == CorrectEdit)
				CorrectEdit_TextValueChanged(event);
			else if (object == VelEdit)
				VelEdit_TextValueChanged(event);
			else if (object == DepEdit)
				DepEdit_TextValueChanged(event);
			else if (object == IFaceEdit)
				IFaceEdit_TextValueChanged(event);
		}
	}

    
	void TestEdit_TextValueChanged(java.awt.event.TextEvent event)
	{
		// Update the List with the new value
		/*if (Text_Typed) {
		 Text_Typed = false;   
		 int i = ResetList.getSelectedIndex();
		 if (i != -1 ) {
	     String cad = ResetList.getSelectedItem();	 
		 int j = cad.indexOf("=");
		 ResetList.replaceItem(cad.substring(0,j+1)+TestEdit.getText(), i);
		 ResetList.select(i);
		 } 
		}*/	 
	}

	class SymKey extends java.awt.event.KeyAdapter
	{
		public void keyPressed(java.awt.event.KeyEvent event)
		{
			Object object = event.getSource();
			if (object == StaName)
				StaName_KeyPressed(event);
			else if (object == LatEdit)
				LatEdit_KeyPressed(event);
			else if (object == LonEdit)
				LonEdit_KeyPressed(event);
			else if (object == AltEdit)
				AltEdit_KeyPressed(event);
			else if (object == CorrectEdit)
				CorrectEdit_KeyPressed(event);
			else if (object == TestEdit)
				TestEdit_KeyPressed(event);
			else if (object == VelEdit)
				VelEdit_KeyPressed(event);
			else if (object == DepEdit)
				DepEdit_KeyPressed(event);
			else if (object == IFaceEdit)
				IFaceEdit_KeyPressed(event);
		}

		public void keyTyped(java.awt.event.KeyEvent event)
		{
			Object object = event.getSource();
			if (object == TestEdit)
				TestEdit_KeyTyped(event);
			else if (object == StaName)
				StaName_KeyTyped(event);
			else if (object == LatEdit)
				LatEdit_KeyTyped(event);
			else if (object == LonEdit)
				LonEdit_KeyTyped(event);
			else if (object == AltEdit)
				AltEdit_KeyTyped(event);
			else if (object == CorrectEdit)
				CorrectEdit_KeyTyped(event);
			else if (object == VelEdit)
				VelEdit_KeyTyped(event);
			else if (object == DepEdit)
				DepEdit_KeyTyped(event);
			else if (object == IFaceEdit)
				IFaceEdit_KeyTyped(event);
		}
	}

	void TestEdit_KeyTyped(java.awt.event.KeyEvent event)
	{
		// A character was type
        Text_Typed = true;		
			 
	}
	
	
	void StaList_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		// Update the station parameters boxe
		//if ( VALID ) {
	     String cad = StaList.getSelectedItem();	 
	     StaName.setText(Format.getItemfrom(cad,1,','));
	     LatEdit.setText(Format.getItemfrom(cad,2,','));
	     LonEdit.setText(Format.getItemfrom(cad,3,','));
	     AltEdit.setText(Format.getItemfrom(cad,4,','));
	     CorrectEdit.setText(Format.getItemfrom(cad,5,','));
	     if( !Text_Typed )
	      STAINDEX = StaList.getSelectedIndex();
	   /* } else
	    if (STAINDEX!=-1)
	     StaList.select(STAINDEX);
	      else StaList.deselect(StaList.getSelectedIndex());  */
	}

	void StaName_TextValueChanged(java.awt.event.TextEvent event)
	{
	// Check if has been typed a text and update the list
		// with the station name
		/*if (Text_Typed) {
		 Text_Typed = false;   
		 int i = StaList.getSelectedIndex();
		 if (i != -1 ) {
	     String cad = StaList.getSelectedItem();	 
		 int j = cad.indexOf(",");
		 StaList.replaceItem(Format.fixwidth(StaName.getText(),5,false)+cad.substring(j), i);
		 StaList.select(i);
		 } 
		}	*/		 
	}

	void StaName_KeyTyped(java.awt.event.KeyEvent event)
	{
		// Station Name is modified (Text typed)
		Text_Typed = true;	 
	}

	void LatEdit_TextValueChanged(java.awt.event.TextEvent event)
	{
	// Check if has been typed a text and update the list
		// with the latitude
		/*if (Text_Typed) {
		 Text_Typed = false;   
		 int i = StaList.getSelectedIndex();
		 if (i != -1 ) {
	     String cad = StaList.getSelectedItem();	 
		 int j = 0;
		 String cad1 = "";
		 int l = 0;
		 int k;
		 for( k=0; k<1; ++k) {
		   j = cad.indexOf(',',l); 
		   cad1 = cad1 + cad.substring(l,j+1);  
		   l = j+1;
		 }  
		 j = cad.indexOf(',',l); 
		 StaList.replaceItem(cad1+Format.fixwidth(LatEdit.getText(),7,true)+cad.substring(j) , i);
		 StaList.select(i);
		 } 
		}	*/		 
	}

	void LatEdit_KeyTyped(java.awt.event.KeyEvent event)
	{		
		// Latitude is modified (Text typed)
		Text_Typed = true;	 	 
	}

	void LonEdit_TextValueChanged(java.awt.event.TextEvent event)
	{
	// Check if has been typed a text and update the list
		// with the longitude
		/*if (Text_Typed) {
		 Text_Typed = false;   
		 int i = StaList.getSelectedIndex();
		 if (i != -1 ) {
	     String cad = StaList.getSelectedItem();	 
		 int j = 0;
		 String cad1 = "";
		 int l = 0;
		 int k;
		 for( k=0; k<2; ++k) {
		   j = cad.indexOf(',',l); 
		   cad1 = cad1 + cad.substring(l,j+1);  
		   l = j+1;
		 }  
		 j = cad.indexOf(',',l); 
		 StaList.replaceItem( cad1+Format.fixwidth(LonEdit.getText(),8,true)+cad.substring(j), i);
		 StaList.select(i);
		 } 
		}*/
			 
	}

	void LonEdit_KeyTyped(java.awt.event.KeyEvent event)
	{
   // Longitude is modified (Text typed)
		Text_Typed = true;	 	 		
	}

	void AltEdit_TextValueChanged(java.awt.event.TextEvent event)
	{
	 // Check if has been typed a text and update the list
		// with the Elevation
		/*if (Text_Typed) {
		 Text_Typed = false;   
		 int i = StaList.getSelectedIndex();
		 if (i != -1 ) {
	     String cad = StaList.getSelectedItem();	 
		 int j = 0;
		 String cad1 = "";
		 int l = 0;
		 int k;
		 for( k=0; k<3; ++k) {
		   j = cad.indexOf(',',l); 
		   cad1 = cad1 + cad.substring(l,j+1);  
		   l = j+1;
		 }  
		 j = cad.indexOf(',',l); 
		 StaList.replaceItem( cad1+Format.fixwidth(AltEdit.getText(),4,true)+cad.substring(j), i);
		 StaList.select(i);
		 } 
		}*/
			 
	}

	void AltEdit_KeyTyped(java.awt.event.KeyEvent event)
	{
	// Altitude is modified (Text typed)
		Text_Typed = true;	 	 						 
	}

	void CorrectEdit_TextValueChanged(java.awt.event.TextEvent event)
	{
		// Check if has been typed a text and update the list
		// with the component
		/*if (Text_Typed) {
		 Text_Typed = false;   
		 int i = StaList.getSelectedIndex();
		 if (i != -1 ) {
	     String cad = StaList.getSelectedItem();	 
		 int j = 0;
		 String cad1 = "";
		 int l = 0;
		 int k;
		 for( k=0; k<4; ++k) {
		   j = cad.indexOf(',',l); 
		   cad1 = cad1 + cad.substring(l,j+1);  
		   l = j+1;
		 }  
		 StaList.replaceItem( cad1+Format.fixwidth(CorrectEdit.getText(),6,true), i);
		 StaList.select(i);
		 } 
		}		 */
	}

	void CorrectEdit_KeyTyped(java.awt.event.KeyEvent event)
	{
		// P-Delay is modified (Text typed)
		Text_Typed = true;	 	 			 
	}

	void ModelList_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		// Update the editing box for Velocity and Depth
	  //if (VALID) {	
		String cad = ModelList.getSelectedItem();	 
		int j = cad.indexOf(",");
		VelEdit.setText(cad.substring(0,j));
		cad = cad.substring(j+1);
		j = cad.indexOf(",");
		DepEdit.setText(cad.substring(0,j));
		IFaceEdit.setText(cad.substring(j+1));
		if( !Text_Typed )
		 MODELINDEX = ModelList.getSelectedIndex();
	  /*} else
	   if( MODELINDEX!=-1 )
	    ModelList.select(MODELINDEX);
	   else ModelList.deselect(ModelList.getSelectedIndex()); */
	    
	}

	void VelEdit_TextValueChanged(java.awt.event.TextEvent event)
	{
		// Check if has been typed a text and update the list
		// with the velocity
	/*	if (Text_Typed) {
		 Text_Typed = false;   
		 int i = ModelList.getSelectedIndex();
		 if (i != -1 ) {
	     String cad = ModelList.getSelectedItem();	 
		 int j = cad.indexOf(",");
		 ModelList.replaceItem(Format.fixwidth(VelEdit.getText(),7,true)+cad.substring(j), i);
		 ModelList.select(i);
		 } 
		} */
	}

	void VelEdit_KeyTyped(java.awt.event.KeyEvent event)
	{
   // Velocity is modified (Text typed)
		Text_Typed = true;	 	 			 					 
	}

	void DepEdit_TextValueChanged(java.awt.event.TextEvent event)
	{
			// Check if has been typed a text and update the list
		// with the depth interface
		/*if (Text_Typed) {
		 Text_Typed = false;   
		 int i = ModelList.getSelectedIndex();
		 if (i != -1 ) {
	     String cad = ModelList.getSelectedItem();	 
		 int j = 0;
		 String cad1 = "";
		 int l = 0;
		 int k;
		 for( k=0; k<1; ++k) {
		   j = cad.indexOf(',',l); 
		   cad1 = cad1 + cad.substring(l,j+1);  
		   l = j+1;
		 }  
		 j = cad.indexOf(',',l); 
		 ModelList.replaceItem(cad1+Format.fixwidth(DepEdit.getText(),7,true)+cad.substring(j) , i);
		 ModelList.select(i);
		 } 
		}			 */
			 
	}

	void DepEdit_KeyTyped(java.awt.event.KeyEvent event)
	{
	// Depth Interface is modified (Text typed)
		Text_Typed = true;	 	 			 					 	
	}

	void IFaceEdit_TextValueChanged(java.awt.event.TextEvent event)
	{
	// Check if has been typed a text and update the list
		// with the moho mark
	/*	if (Text_Typed) {
		 Text_Typed = false;   
		 int i = ModelList.getSelectedIndex();
		 if (i != -1 ) {
	     String cad = ModelList.getSelectedItem();	 
		 int j = 0;
		 String cad1 = "";
		 int l = 0;
		 int k;
		 for( k=0; k<2; ++k) {
		   j = cad.indexOf(',',l); 
		   cad1 = cad1 + cad.substring(l,j+1);  
		   l = j+1;
		 }  
		 ModelList.replaceItem( cad1+IFaceEdit.getText(), i);
		 ModelList.select(i);
		 } 
		}		*/
			 
	}

	void IFaceEdit_KeyTyped(java.awt.event.KeyEvent event)
	{
    // moho mark is modified (Text typed)
		Text_Typed = true;	 	 			 					 				 
	}

	void AddSta_ActionPerformed(java.awt.event.ActionEvent event)
	{	
	 // add new station   
	 if ( Format.Validate("Station Name",StaName.getText(),5,'S',false,'0',"") && Format.Validate("Latitude of the station",LatEdit.getText(),15,'F',false,'R',LatRange)
	      &&  Format.Validate("Longitude of the station",LonEdit.getText(),15,'F',false,'R',LonRange) && Format.Validate("Elevation",AltEdit.getText(),15,'F',false,'R',AltRange)
	      && Format.Validate("P-Delay of the station",CorrectEdit.getText(),15,'F',true,'R',CorrRange) ) {
	   StaList.add(StaName.getText()+","+LatEdit.getText()+","+LonEdit.getText()+","+AltEdit.getText()+","+CorrectEdit.getText());
	   StaList.select(StaList.getItemCount()-1);
	   StaTransp.add("  ");
	   }
	}

	void RemSta_ActionPerformed(java.awt.event.ActionEvent event)
	{
	  // remove the station
	  int i=-1;
	  if( (i=StaList.getSelectedIndex())!=-1) {
	   StaList.remove(i);
	   StaTransp.remove(i);
	  } 
			 
	}
	

	void AddLayer_ActionPerformed(java.awt.event.ActionEvent event)
	{
	// add new layer   
	 if ( Format.Validate("Velocity in the model",VelEdit.getText(),15,'F',false,'R',VelRange) 
	      && Format.Validate("Depth in the model",DepEdit.getText(),15,'F',false,'R',DepRange)
	      &&  Format.Validate("Interface indicator",IFaceEdit.getText(),1,'S',true,'U',IFaceSet) ) {
	   ModelList.add(VelEdit.getText()+","+DepEdit.getText()+","+IFaceEdit.getText());
	   ModelList.select(ModelList.getItemCount()-1);	
	   ModelTransp.add("   ");
	   }	
			 
	}

	void RemLayer_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// remove the layer
	  int i=-1;	 
	  if( (i=ModelList.getSelectedIndex())!=-1)	{
	    ModelList.remove(i);	 
	    ModelTransp.remove(i);
	  } 
	}

	void UsedCheck_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		// Update the List with "*"
	  if( ResetList.getSelectedIndex()!=-1) {
		String cad = ResetList.getSelectedItem();
		int i = ResetList.getSelectedIndex();
		if( UsedCheck.getState() )
		 ResetList.replaceItem("*"+cad.substring(1), i);
		else if (cad.charAt(0)=='*') 
		  ResetList.replaceItem(" "+cad.substring(1), i);
		ResetList.select(i);  	  
	  }	  
	}
	
  void ReadFile(String FILENAME) {
    // Read STATION0.HYP
     File file = new File(FILENAME);
     if ( file.exists() ) {
	  try {
       System.out.println("Reading file:" + FILENAME);
       FileInputStream fileIn = new FileInputStream(FILENAME);
	   BufferedReader in = new BufferedReader(
				new InputStreamReader(fileIn));  
      String inputLine;
	  while ( (inputLine = in.readLine()) != null ) {
	    // Reading RESET TEST
	    while (inputLine.trim().length()>0) {
	     FixResetList(Format.fixwidth(inputLine,80,false)); 
	     inputLine = in.readLine();
	    }
	    // Jump blank lines
        while ( inputLine.trim().length()==0 ) inputLine = in.readLine();
        // Reading Station List
        while (inputLine.trim().length()>0) {
	     AddStaList(Format.fixwidth(inputLine,80,false)); 
	     inputLine = in.readLine();
	    }
        // Jump blank lines
        while ( inputLine.trim().length()==0 ) inputLine = in.readLine();
        // Reading Velocity Model
        while (inputLine.trim().length()>0) {
	     AddModelList(Format.fixwidth(inputLine,80,false)); 
	     inputLine = in.readLine();
	    }
	    // Jump blank lines
        while ( inputLine.trim().length()==0 ) inputLine = in.readLine();
        AddControlLine(Format.fixwidth(inputLine,80,false));
        inputLine = in.readLine();
        if ( inputLine.trim().length()>0 ) 
          AgencyEdit.setText(inputLine.trim());
        break;  
      }  
	  in.close();  
	  fileIn.close();
	 }catch (IOException Ex)
        {
           System.out.println(Ex.getMessage());
        }    
  } else { 
      OKDialog.createOKDialog("File:"+ FILENAME+" not found");	
      NOTFILE = true;
    }  
  } 
  
  void WriteFile(String FILENAME) {
    int i=0;
    try {
      System.out.println("Saving file:" + FILENAME);  
      FileOutputStream fileOut = new FileOutputStream(FILENAME);
      PrintWriter out = new PrintWriter(fileOut);
	  WriteResetList(out);
	  out.println("                           ");
      WriteStaList(out);
      out.println("                           ");
      WriteModelList(out);
      out.println("                           ");
      WriteControlLine(out);
      out.println(Format.fixwidth(AgencyEdit.getText(),3,false));
	  out.close();  
	  fileOut.close();
	 }catch (IOException Ex)
        {
           OKDialog.createOKDialog("You don not have permit to write on this directory"); 
           System.out.println(Ex.getMessage());
        }
  }
  
  void resetTest() {
    int n = ResetList.getItemCount();
    String cad;
    int i=0;
    while( i<n ) {
      cad = ResetList.getItem(i);    
      if  (cad.charAt(0)=='*')  
        ResetList.replaceItem(" "+cad.substring(1),i);
      ++i;  
    }   
  }
  
  void FixResetList(String item) {
    // Find item in ResetList and replaced it 
    int n = ResetList.getItemCount();
    String num="";
    int i=0;
    int j = item.indexOf(")");
    int k = item.indexOf("(")+1;
    String number = item.substring(k, j);
    k = item.indexOf("=");
    item = item.substring(k).trim();
    String cad="";
    while( i<n ) {
      cad = ResetList.getItem(i);    
      j = cad.indexOf(")");
      k = cad.indexOf("(")+1;
      num = cad.substring(k, j);  
      j = cad.indexOf("=");
      if ( (number.compareTo(num)==0) && (cad.charAt(0)!='*') ) {
        ResetList.replaceItem("*"+cad.substring(1, j)+item,i);
        break;
      }  
      ++i;
    }    
  }
  
  void AddStaList(String item) {
    // add the station parameter to the list
    StaTransp.add(item);
    String tmp;
    //System.out.println(item);
    String  cad = Format.fixwidth(item.substring(1, 6).trim(),5,true);
    tmp = item.substring(6, 8).trim();
    if( tmp.length()==0 ) tmp="0";
    double Lat = (new Integer(tmp)).floatValue();
    tmp = item.substring(8, 13).trim();
    if( tmp.length()==0 ) tmp="0";
    double dlat = (new Double(tmp)).doubleValue();
    if( tmp.indexOf(".")==-1 ) dlat = dlat/1000.0; // dot not present
    tmp = item.substring(14, 17).trim();
    if( tmp.length()==0 ) tmp="0";
    double Lon = (new Float(tmp)).floatValue();
    tmp = item.substring(17, 22).trim();
    if( tmp.length()==0 ) tmp="0";
    double dlon = (new Double(tmp)).doubleValue();
    if( tmp.indexOf(".")==-1 ) dlon = dlon/1000.0;
    Lat = Lat + dlat/60.0;
    Lon = Lon + dlon/60.0;
    if (item.charAt(13)=='S') Lat = -Lat;
    if (item.charAt(22)=='W') Lon = -Lon;
    cad=cad + "," + Format.fixwidth(Format.fixdec((new Double(Lat)).toString(),4),8,true);
    cad=cad + "," + Format.fixwidth(Format.fixdec((new Double(Lon)).toString(),4),9,true);
    cad=cad + "," + item.substring(23,27);
    cad=cad + "," + item.substring(27,33);
    StaList.add(cad);
  }  
  
   void AddModelList(String item) {
    // add the station parameter to the list
    ModelTransp.add(item);
    String  cad = Format.fixwidth(Format.fixdec(item.substring(0, 7),3),7,true);
    cad=cad + "," + Format.fixwidth(Format.fixdec(item.substring(10,16),2),6,true);
    cad=cad + "," + item.substring(21,22);
    ModelList.add(cad);
  }
  
  void AddControlLine(String item ) {
    // Put the control line parameters in the edit boxes
    StrDepEdit.setText(item.substring(0, 5).trim());
    XnearEdit.setText(item.substring(5, 10).trim());
    XfarEdit.setText(item.substring(10, 15).trim());
    VpVsEdit.setText(item.substring(15, 20).trim());
    NDepEdit.setText(item.substring(20, 25).trim());
    InitDepEdit.setText(item.substring(25, 30).trim());
    IncDepEdit.setText(item.substring(30, 35).trim());
  }
  
  
  void WriteResetList(PrintWriter out) {
    // Save the Reset Test List in station0.hyp
    int n = ResetList.getItemCount();
    int i,j,k,l;
    String item;
    for(i=0; i<n ; ++i) {
      item = ResetList.getItem(i);
      j = item.indexOf("(");
      k = item.indexOf(")")+1;
      l = item.indexOf("=");
      if (item.charAt(0)=='*') 
       out.println("RESET TEST"+item.substring(j,k)+item.substring(l).trim());
    }    
  }
  
void WriteStaList(PrintWriter out) {
    // Save the station List in station0.hyp
    int n = StaList.getItemCount();
    int i;
    String item;
    for(i=0; i<n ; ++i) {          
      String cad ="";  
      item = StaList.getItem(i);
      String val = Format.getItemfrom(item,1,','); //station name
      if ( val.length()<5 ) val = " " + val;
      cad = cad + " " + Format.fixwidth(val,5,false);
	  val = Format.getItemfrom(item,2,','); // Latitude 
	  int grad = (new Float(val)).intValue();
	  float dgrad = Math.abs((new Float(val)).floatValue()) - Math.abs(grad);
	  val = (new Integer(Math.abs(grad))).toString();
	  cad = cad + Format.fixwidth(val,2,true);
	  dgrad = dgrad * 60 * 1000; //high precision
	  val = (new Integer((int)dgrad)).toString();   
	  //val = Format.fixdec(val,2);
      cad = cad + Format.fixwidth(val,5,true);
      if (grad<0) cad = cad + "S";
      else cad = cad + "N";
      val = Format.getItemfrom(item,3,','); // Longitude 
	  grad = (new Float(val)).intValue();
	  dgrad = Math.abs((new Float(val)).floatValue()) - Math.abs(grad);
	  val = (new Integer(Math.abs(grad))).toString();
	  cad = cad + Format.fixwidth(val,3,true);
	  dgrad = dgrad * 60 * 1000;
	  val = (new Integer((int)dgrad)).toString();   
	  //val = Format.fixdec(val,2);
      cad = cad + Format.fixwidth(val,5,true);
      if (grad<0) cad = cad + "W";
      else cad = cad + "E";
      val = Format.getItemfrom(item,4,','); // Elevation 
	  val = Format.fixdec(val,-1);
      cad = cad + Format.fixwidth(val,4,true);
      val = Format.getItemfrom(item,5,','); // P-delay 
	  val = Format.fixdec(val,2);
      cad = cad + Format.fixwidth(val,6,true);
      cad = cad + StaTransp.getItem(i).substring(33);
      out.println(cad);
     }   
  }   
  
  void WriteModelList(PrintWriter out) {
    // Save the station List in station0.hyp
    int n = ModelList.getItemCount();
    int i;
    String item;
    for(i=0; i<n ; ++i) {          
      String cad ="";  
      item = ModelList.getItem(i);
      String val = Format.getItemfrom(item,1,','); //velocity
      val = Format.fixdec(val,3);
      cad = cad + Format.fixwidth(val,7,true);
      val = Format.getItemfrom(item,2,','); // Depth 
	  val = Format.fixdec(val,2);
      cad = cad + Format.fixwidth(val,9,true);
      cad = cad + Format.fixwidth("",5,true);
      val = Format.getItemfrom(item,3,','); // Interface
      cad = cad + Format.fixwidth(val,1,true);
      cad = cad + ModelTransp.getItem(i).substring(22);
      out.println(cad);
     }   
     
  }  
  
   void WriteControlLine(PrintWriter out) {
     String cad = "";
     String val = Format.fixdec(StrDepEdit.getText(),1);
     cad = cad + Format.fixwidth(val,5,false);
     val = Format.fixdec(XnearEdit.getText(),0);
     cad = cad + Format.fixwidth(val,5,false);
     val = Format.fixdec(XfarEdit.getText(),0);
     cad = cad + Format.fixwidth(val,5,false);
     val = Format.fixdec(VpVsEdit.getText(),2);
     cad = cad + Format.fixwidth(val,5,true);
     val = Format.fixdec(NDepEdit.getText(),-1);
     cad = cad + Format.fixwidth(val,5,true);
     val = Format.fixdec(InitDepEdit.getText(),1);
     cad = cad + Format.fixwidth(val,5,true);
     val = Format.fixdec(IncDepEdit.getText(),1);
     cad = cad + Format.fixwidth(val,5,true);
     out.println(cad);
   } 

  void getResetListDef() {
     // Read STATIONDEF.INP used for data validation and help
     String filename = INPUTDEF_DIR + "STATIONDEF.INP";
     File file = new File(filename);
     if ( file.exists() ) {
	  try {
       System.out.println("Reading file:" + filename);
       FileInputStream fileIn = new FileInputStream(filename);
	   BufferedReader in = new BufferedReader(
				new InputStreamReader(fileIn));  
      String inputLine;
      int i = 0;
      in.readLine();
      in.readLine();
      String cad;
	  while ( (inputLine = in.readLine()) != null ) {
	    TESTHELP[i]=new String("");
	    cad = ResetList.getItem(i);
	    int l = cad.indexOf("=");
	    int j = inputLine.indexOf(":");
	    int k = inputLine.indexOf(",");
		ResetList.replaceItem(cad.substring(0,l+1)+inputLine.substring(j+1,k), i);
		RTEST[i] = new String(inputLine);
		while( ((inputLine = in.readLine()) != null ) && (inputLine.trim().length()>0) )
	     TESTHELP[i] = TESTHELP[i]+new String(inputLine)+"\n";
	    ++i;  
	  } 
	  in.close();
	  fileIn.close();
	 }catch (IOException Ex)
        {
           System.out.println(Ex.getMessage());
        }    
  } else { 
      OKDialog.createOKDialog("File: "+filename+" not found");	
      NOTFILE = true;
   }
  }  

	class SymFocus extends java.awt.event.FocusAdapter
	{
		public void focusGained(java.awt.event.FocusEvent event)
		{
			Object object = event.getSource();
			if (object == StaList)
				StaList_FocusGained(event);
			else if (object == ModelList)
				ModelList_FocusGained(event);
			else if (object == StrDepEdit)
				StrDepEdit_FocusGained(event);
			else if (object == XnearEdit)
				XnearEdit_FocusGained(event);
			else if (object == XfarEdit)
				XfarEdit_FocusGained(event);
			else if (object == VpVsEdit)
				VpVsEdit_FocusGained(event);
			else if (object == NDepEdit)
				NDepEdit_FocusGained(event);
			else if (object == InitDepEdit)
				InitDepEdit_FocusGained(event);
			else if (object == IncDepEdit)
				IncDepEdit_FocusGained(event);
			else if (object == Modelchoice)
				Modelchoice_FocusGained(event);
			else if (object == StaName)
				StaName_FocusGained(event);
			else if (object == LatEdit)
				LatEdit_FocusGained(event);
			else if (object == LonEdit)
				LonEdit_FocusGained(event);
			else if (object == AltEdit)
				AltEdit_FocusGained(event);
			else if (object == CorrectEdit)
				CorrectEdit_FocusGained(event);
			else if (object == AgencyEdit)
				AgencyEdit_FocusGained(event);
			else if (object == VelEdit)
				VelEdit_FocusGained(event);
			else if (object == DepEdit)
				DepEdit_FocusGained(event);
			else if (object == IFaceEdit)
				IFaceEdit_FocusGained(event);
		}

		public void focusLost(java.awt.event.FocusEvent event)
		{
			Object object = event.getSource();
			if (object == TestEdit)
				TestEdit_FocusLost(event);
			else if (object == StaName)
				StaName_FocusLost(event);
			else if (object == LatEdit)
				LatEdit_FocusLost(event);
			else if (object == LonEdit)
				LonEdit_FocusLost(event);
			else if (object == AltEdit)
				AltEdit_FocusLost(event);
			else if (object == CorrectEdit)
				CorrectEdit_FocusLost(event);
			else if (object == VelEdit)
				VelEdit_FocusLost(event);
			else if (object == DepEdit)
				DepEdit_FocusLost(event);
			else if (object == IFaceEdit)
				IFaceEdit_FocusLost(event);
			else if (object == StrDepEdit)
				StrDepEdit_FocusLost(event);
			else if (object == XnearEdit)
				XnearEdit_FocusLost(event);
			else if (object == XfarEdit)
				XfarEdit_FocusLost(event);
			else if (object == VpVsEdit)
				VpVsEdit_FocusLost(event);
			else if (object == NDepEdit)
				NDepEdit_FocusLost(event);
			else if (object == InitDepEdit)
				InitDepEdit_FocusLost(event);
			else if (object == IncDepEdit)
				IncDepEdit_FocusLost(event);
		}
	}

	void TestEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check the value
		cadvalue = TestEdit.getText();
		if( !Text_Typed ) return;
		int i = PREVINDEX;
		if (i!=-1) {
		 String item = ResetList.getItem(i);
		 int j = RTEST[i].indexOf(":")+1;
		 String cad = RTEST[i].substring(j);
		 char R = (Format.getItemfrom(cad,2,',')).charAt(0);
		 j = cad.indexOf(",");
		 j = cad.indexOf(",",j+1);
		 String Range = cad.substring(j+1);
		 VALID = Format.Validate(item,cadvalue,10,'F',false,R,Range); 
		 if ( VALID ){ 
		  j = item.indexOf("=");
		  ResetList.replaceItem(item.substring(0,j+1)+cadvalue, i);
		  if( ResetList.getSelectedIndex()==-1) 
		   ResetList.select(i);
		 } else PREVINDEX=ResetList.getSelectedIndex();
		} 
		Text_Typed = false;
	}

    
	void StaName_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check station name be less than 5 character
		cadvalue = StaName.getText().trim();
		if( !Text_Typed ) return;
		if (STAINDEX!=-1) {    
		 VALID = Format.Validate("Station Name",cadvalue,5,'S',false,'0',""); 		 
		 if (VALID) {
		  String cad = StaList.getItem(STAINDEX);	 
		  int j = cad.indexOf(",");
		  StaList.replaceItem(Format.fixwidth(cadvalue,5,true)+cad.substring(j),STAINDEX);
		  if (StaList.getSelectedIndex()==-1)
		    StaList.select(STAINDEX);  
		 }else STAINDEX=StaList.getSelectedIndex();   
		} 
		Text_Typed = false;
	}

	void LatEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check Latitude
	  cadvalue = LatEdit.getText();	
	  if( !Text_Typed ) return;	
	  if (STAINDEX!=-1) {
	   VALID = Format.Validate("Station Latitude",cadvalue,15,'F',false,'R',LatRange);
		if ( VALID ) {
		 String cad = StaList.getItem(STAINDEX);	 
		 int j = 0;
		 String cad1 = "";
		 int l = 0;
		 int k;
		 for( k=0; k<1; ++k) {
		   j = cad.indexOf(',',l); 
		   cad1 = cad1 + cad.substring(l,j+1);  
		   l = j+1;
		 }  
		 j = cad.indexOf(',',l); 
		 StaList.replaceItem(cad1+Format.fixwidth(cadvalue,8,true)+cad.substring(j) , STAINDEX);
		 if (StaList.getSelectedIndex()==-1)
		   StaList.select(STAINDEX);
		} else STAINDEX=StaList.getSelectedIndex();   
	  }
	  Text_Typed = false;
	}

	void LonEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check Latitude
		cadvalue = LonEdit.getText();
		if( !Text_Typed ) return;
		if (STAINDEX!=-1) {  
		 VALID = Format.Validate("Station Longitude",cadvalue,15,'F',false,'R',LonRange);
		 if (VALID) {
		    String cad = StaList.getItem(STAINDEX);	 
		 int j = 0;
		 String cad1 = "";
		 int l = 0;
		 int k;
		 for( k=0; k<2; ++k) {
		   j = cad.indexOf(',',l); 
		   cad1 = cad1 + cad.substring(l,j+1);  
		   l = j+1;
		 }  
		 j = cad.indexOf(',',l); 
		 StaList.replaceItem( cad1+Format.fixwidth(cadvalue,9,true)+cad.substring(j), STAINDEX);
		 if (StaList.getSelectedIndex()==-1)
		  StaList.select(STAINDEX);
		 } else STAINDEX=StaList.getSelectedIndex();     
		} 
		Text_Typed = false;
	}

	void AltEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check Elevation
		cadvalue = AltEdit.getText();
		if( !Text_Typed ) return;
		if (STAINDEX!=-1) {
		 VALID = Format.Validate("Station Elevation",cadvalue,15,'F',false,'R',AltRange);
		 if( VALID ) {
		    String cad = StaList.getItem(STAINDEX);	 
		 int j = 0;
		 String cad1 = "";
		 int l = 0;
		 int k;
		 for( k=0; k<3; ++k) {
		   j = cad.indexOf(',',l); 
		   cad1 = cad1 + cad.substring(l,j+1);  
		   l = j+1;
		 }  
		 j = cad.indexOf(',',l); 
		 StaList.replaceItem( cad1+Format.fixwidth(cadvalue,4,true)+cad.substring(j), STAINDEX);
		 if (StaList.getSelectedIndex()==-1)
		  StaList.select(STAINDEX);
		 } else STAINDEX=StaList.getSelectedIndex();     
		} 
		Text_Typed = false;
	}

	void CorrectEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check P-delay
		cadvalue = CorrectEdit.getText();
		if( !Text_Typed ) return;
		if (STAINDEX!=-1) {  
		 VALID = Format.Validate("Station P-delay",cadvalue,15,'F',false,'R',CorrRange);
		 if( VALID ) {
		    String cad = StaList.getItem(STAINDEX);	 
		 int j = 0;
		 String cad1 = "";
		 int l = 0;
		 int k;
		 for( k=0; k<4; ++k) {
		   j = cad.indexOf(',',l); 
		   cad1 = cad1 + cad.substring(l,j+1);  
		   l = j+1;
		 }  
		 StaList.replaceItem( cad1+Format.fixwidth(cadvalue,6,true),STAINDEX);
		 if (StaList.getSelectedIndex()==-1 )
		  StaList.select(STAINDEX);
		 } else STAINDEX=StaList.getSelectedIndex();      
		} 
		Text_Typed = false;
	}

	void VelEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check P-Velocity
		cadvalue = VelEdit.getText();
		if( !Text_Typed ) return;
		if (MODELINDEX!=-1) {   
		 VALID = Format.Validate("P-Velocity",cadvalue,15,'F',false,'R',VelRange);
		 if ( VALID ) {
		    String cad = ModelList.getItem(MODELINDEX);	 
		 int j = cad.indexOf(",");
		 ModelList.replaceItem(Format.fixwidth(Format.fixdec(cadvalue,3),7,true)+cad.substring(j), MODELINDEX);
		 if (ModelList.getSelectedIndex() == -1 )
		  ModelList.select(MODELINDEX);
		 } else MODELINDEX=ModelList.getSelectedIndex(); 
		} 
		Text_Typed = false;  
	}

	void DepEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check Depth at interface
		cadvalue = DepEdit.getText();
		if( !Text_Typed ) return;
		if (MODELINDEX!=-1) {   
		 VALID = Format.Validate("Depth at Interface",cadvalue,15,'F',false,'R',DepRange);
		 if( VALID ) {
		    String cad = ModelList.getItem(MODELINDEX);	 
		 int j = 0;
		 String cad1 = "";
		 int l = 0;
		 int k;
		 for( k=0; k<1; ++k) {
		   j = cad.indexOf(',',l); 
		   cad1 = cad1 + cad.substring(l,j+1);  
		   l = j+1;
		 }  
		 j = cad.indexOf(',',l); 
		 ModelList.replaceItem(cad1+Format.fixwidth(Format.fixdec(cadvalue,2),6,true)+cad.substring(j) , MODELINDEX);
		 if ( ModelList.getSelectedIndex()==-1 )
		  ModelList.select(MODELINDEX);
		 } else MODELINDEX=ModelList.getSelectedIndex();  
		} 
		Text_Typed = false; 	 
	}

	void IFaceEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check interface indicator
		cadvalue = IFaceEdit.getText();
		if( !Text_Typed ) return;
		if (MODELINDEX!=-1) {  
		 VALID = Format.Validate("Interface indicator",cadvalue,1,'S',true,'U',IFaceSet);
		 if ( VALID ) {
		    String cad = ModelList.getItem(MODELINDEX);	 
		 int j = 0;
		 String cad1 = "";
		 int l = 0;
		 int k;
		 for( k=0; k<2; ++k) {
		   j = cad.indexOf(',',l); 
		   cad1 = cad1 + cad.substring(l,j+1);  
		   l = j+1;
		 }  
		 ModelList.replaceItem( cad1+cadvalue, MODELINDEX);
		 if (ModelList.getSelectedIndex()==-1)
		  ModelList.select(MODELINDEX);
		 } else MODELINDEX=ModelList.getSelectedIndex();
		} 
		Text_Typed = false; 	 
	}

	void StrDepEdit_FocusLost(java.awt.event.FocusEvent event)
	{
	 	// Check Start Depth
		VALID = Format.Validate("Starting depth",StrDepEdit.getText(),15,'F',true,'R',"0,999");			 
	}

	void XnearEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check Xnear
		VALID = Format.Validate("Xnear",XnearEdit.getText(),15,'F',true,'R',"0,9999");
			 
	}

	void XfarEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check Xfar
		VALID = Format.Validate("Xfar",XfarEdit.getText(),15,'F',true,'R',"0,99999");
			 
	}

	void VpVsEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check Vp/Vs
		VALID = Format.Validate("Vp/Vs",VpVsEdit.getText(),15,'F',true,'R',"1,3");
			 
	}

	void NDepEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check NDepth
		VALID = Format.Validate("Number of step in depth increment",NDepEdit.getText(),5,'I',true,'R',"0,999");
			 
	}

	void InitDepEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check init depth
		VALID = Format.Validate("Initial depth",InitDepEdit.getText(),15,'F',true,'R',"0,999");
			 
	}

	void IncDepEdit_FocusLost(java.awt.event.FocusEvent event)
	{
		// Check increment Depth
		VALID = Format.Validate("Increment in depth",IncDepEdit.getText(),5,'F',true,'R',"0,99");	 
	}
	
	void getModelFiles() {
	  // get the list of station*.hyp  
	  int i,j;  
    int k=0;
	  boolean found = false;
	  File entry = new File(DIR_TOP);
	  String[] directory = entry.list();
      for(i=0; i<directory.length; ++i) {
       String namemodel = directory[i].toUpperCase();
       if ( (namemodel.indexOf("STATION")!=-1) &&
           ((j=namemodel.indexOf(".HYP"))>7) ) {
         Modelchoice.add(namemodel.substring(7,j));
         filenamelist[k++] = new String(directory[i]);
         found = true;
       }  
      } 
      if ( found ) {
       Modelchoice.select(0);
       FILENAME = DIR_TOP + "STATION" + Modelchoice.getItem(0)+".HYP";
      }  else { 
      OKDialog.createOKDialog("File: FILENAME not found");	
      setVisible(false);
      }  
	}    

	void Modelchoice_ItemStateChanged(java.awt.event.ItemEvent event)
	{
	 //FILENAME = DIR_TOP + "STATION" + Modelchoice.getSelectedItem()+".HYP";		 
   FILENAME = DIR_TOP + filenamelist[Modelchoice.getSelectedIndex()];
   System.out.println(FILENAME);
	 StaList.removeAll();
	 ModelList.removeAll();
	 StaTransp.removeAll();
	 ModelTransp.removeAll();
	 resetTest();
	 ReadFile(FILENAME);
	}

	void StaList_FocusGained(java.awt.event.FocusEvent event)
	{
		// Update the help line
		labelHlp.setText("Station Parameters");	 
	}

	void ModelList_FocusGained(java.awt.event.FocusEvent event)
	{
	// Update the help line
		labelHlp.setText("P-Velocity Model Parameters");	 
			 
	}

	void StrDepEdit_FocusGained(java.awt.event.FocusEvent event)
	{
	 // Update the help line
		labelHlp.setText("Start depth in km, used if no range of start depths specified( NDep, Init-Dep and Inc-Dep are blanks)");	 		 
	}

	void XnearEdit_FocusGained(java.awt.event.FocusEvent event)
	{
	// Update the help line
		labelHlp.setText("Distance at which distance weighting start");	 			 
	}

	void XfarEdit_FocusGained(java.awt.event.FocusEvent event)
	{
		// Update the help line
		labelHlp.setText("Distance at which distance weighting is zero, beyond xfar, the phase is not used (local events only)");	 	 
	}

	void VpVsEdit_FocusGained(java.awt.event.FocusEvent event)
	{
		// Update the help line
		labelHlp.setText("Vp/Vs ratio");	 	 
	}

	void NDepEdit_FocusGained(java.awt.event.FocusEvent event)
	{
		// Update the help line
		labelHlp.setText("Number of start depths");	 	 
	}

	void InitDepEdit_FocusGained(java.awt.event.FocusEvent event)
	{
		// Update the help line
		labelHlp.setText("Initial start depth of range of start depths");	 	 
	}

	void IncDepEdit_FocusGained(java.awt.event.FocusEvent event)
	{
		// Update the help line
		labelHlp.setText("Increments in start depths");	 	 
	}

	void HypDialog_WindowOpened(java.awt.event.WindowEvent event)
	{
		if (NOTFILE) setVisible(false);
	}

	void StaName_KeyPressed(java.awt.event.KeyEvent event)
	{
		if(event.getKeyCode()==10) StaName_FocusLost(new java.awt.event.FocusEvent(this, 0));
			 
	}

	void LatEdit_KeyPressed(java.awt.event.KeyEvent event)
	{
		if(event.getKeyCode()==10) LatEdit_FocusLost(new java.awt.event.FocusEvent(this, 0));
			 
	}

	void LonEdit_KeyPressed(java.awt.event.KeyEvent event)
	{
	  if(event.getKeyCode()==10) LonEdit_FocusLost(new java.awt.event.FocusEvent(this, 0));
			 
	}

	void AltEdit_KeyPressed(java.awt.event.KeyEvent event)
	{
	  if(event.getKeyCode()==10) AltEdit_FocusLost(new java.awt.event.FocusEvent(this, 0));
			 
	}

	void CorrectEdit_KeyPressed(java.awt.event.KeyEvent event)
	{
	 if(event.getKeyCode()==10) CorrectEdit_FocusLost(new java.awt.event.FocusEvent(this, 0));
			 
	}

	void TestEdit_KeyPressed(java.awt.event.KeyEvent event)
	{
	 if(event.getKeyCode()==10) TestEdit_FocusLost(new java.awt.event.FocusEvent(this, 0));
			 
	}

	void VelEdit_KeyPressed(java.awt.event.KeyEvent event)
	{
	 if(event.getKeyCode()==10) VelEdit_FocusLost(new java.awt.event.FocusEvent(this, 0));
			 
	}

	void DepEdit_KeyPressed(java.awt.event.KeyEvent event)
	{
	  if(event.getKeyCode()==10) DepEdit_FocusLost(new java.awt.event.FocusEvent(this, 0));
			 
	}

	void IFaceEdit_KeyPressed(java.awt.event.KeyEvent event)
	{
	  if(event.getKeyCode()==10) IFaceEdit_FocusLost(new java.awt.event.FocusEvent(this, 0));
			 
	}

	void Modelchoice_FocusGained(java.awt.event.FocusEvent event)
	{
		labelHlp.setText("Selecting other STATION?.HYP file. Question mark identifies the item in the combo-box");	 
	}

	void StaName_FocusGained(java.awt.event.FocusEvent event)
	{
		labelHlp.setText("Station Code. Maximum 5 characters");	 
			 
	}

	void LatEdit_FocusGained(java.awt.event.FocusEvent event)
	{
		labelHlp.setText("Station Latitude. Negative for South Latitude");	 
			 
	}

	void LonEdit_FocusGained(java.awt.event.FocusEvent event)
	{
		labelHlp.setText("Station Longitude. Negative for West Longitude");	 
			 
	}

	void AltEdit_FocusGained(java.awt.event.FocusEvent event)
	{
		labelHlp.setText("Station Elevation");	 
			 
	}

	void CorrectEdit_FocusGained(java.awt.event.FocusEvent event)
	{
		labelHlp.setText("Station correction for P-velocity");	 
			 
	}

	void AgencyEdit_FocusGained(java.awt.event.FocusEvent event)
	{
		labelHlp.setText("Reporting agency. Maximum 3 characters");	 
			 
	}

	void VelEdit_FocusGained(java.awt.event.FocusEvent event)
	{
		labelHlp.setText("P-Velocity (km/sec)");	 
			 
	}

	void DepEdit_FocusGained(java.awt.event.FocusEvent event)
	{
		labelHlp.setText("Depth to interface (km)");
			 
	}

	void IFaceEdit_FocusGained(java.awt.event.FocusEvent event)
	{
		labelHlp.setText("Interface indicator: N:Moho, B:Conrad");	 
			 
	}
}
